#! /bin/sh
#
# This script adjusts hard drive APM settings using hdparm. The hardware
# defaults (usually hdparm -B 128) cause excessive head load/unload cycles
# on many modern hard drives. We therefore set hdparm -B 254 while on AC
# power. On battery we set hdparm -B 128, because the head parking is
# very useful for shock protection.
#

DO_HDPARM=y
if [ -e /usr/sbin/laptop_mode ] ; then 
  LMT_CONTROL_HD_POWERMGMT=$(. /etc/laptop-mode/laptop-mode.conf && echo "$CONTROL_HD_POWERMGMT")
  if [ "$LMT_CONTROL_HD_POWERMGMT" != 0 ] ; then
    # Laptop mode controls hdparm -B settings, we don't.
    DO_HDPARM=n
  fi
fi

if [ $DO_HDPARM = y ] ; then
  AC_POWER=$( /usr/bin/on_ac_power; echo $? )
  for dev in /dev/sd? /dev/hd? ; do
    if [ -b $dev ] ; then
      if [ $AC_POWER -eq 1 ] ; then
        hdparm -B 128 $dev
      else
        hdparm -B 254 $dev
      fi
    fi
  done
fi

